GroovyRecognizer (Groovy 2.4.14)
Date: 2018-02-24

org.codehaus.groovy.antlr.parser

## Class GroovyRecognizer

- java.lang.Object
- - antlr.Parser
  - - antlr.LLkParser
    - - org.codehaus.groovy.antlr.parser.GroovyRecognizer

- All Implemented Interfaces:
    GroovyTokenTypes

      public class GroovyRecognizer
      extends LLkParser
      implements GroovyTokenTypes

  JSR-241 Groovy Recognizer. Run 'java Main [-showtree] directory-full-of-groovy-files' [The -showtree option pops up a Swing frame that shows the AST constructed from the parser.] Contributing authors: John Mitchell johnm@non.net Terence Parr parrt@magelang.com John Lilley jlilley@empathy.com Scott Stanchfield thetick@magelang.com Markus Mohnen mohnen@informatik.rwth-aachen.de Peter Williams pete.williams@sun.com Allan Jacobs Allan.Jacobs@eng.sun.com Steve Messick messick@redhills.com James Strachan jstrachan@protique.com John Pybus john@pybus.org John Rose rose00@mac.com Jeremy Rayner groovy@ross-rayner.com Alex Popescu the.mindstorm@gmail.com Martin Kempf mkempf@hsr.ch Reto Kleeb rkleeb@hsr.ch Version 1.00 December 9, 1997 -- initial release Version 1.01 December 10, 1997 fixed bug in octal def (0..7 not 0..8) Version 1.10 August 1998 (parrt) added tree construction fixed definition of WS,comments for mac,pc,unix newlines added unary plus Version 1.11 (Nov 20, 1998) Added "shutup" option to turn off last ambig warning. Fixed inner class def to allow named class defs as statements synchronized requires compound not simple statement add [] after builtInType DOT class in primaryExpression "const" is reserved but not valid..removed from modifiers Version 1.12 (Feb 2, 1999) Changed LITERAL_xxx to xxx in tree grammar. Updated java.g to use tokens {...} now for 2.6.0 (new feature). Version 1.13 (Apr 23, 1999) Didn't have (stat)? for else clause in tree parser. Didn't gen ASTs for interface extends. Updated tree parser too. Updated to 2.6.0. Version 1.14 (Jun 20, 1999) Allowed final/abstract on local classes. Removed local interfaces from methods Put instanceof precedence where it belongs...in relationalExpr It also had expr not type as arg; fixed it. Missing ! on SEMI in classBlock fixed: (expr) + "string" was parsed incorrectly (+ as unary plus). fixed: didn't like Object[].class in parser or tree parser Version 1.15 (Jun 26, 1999) Screwed up rule with instanceof in it. :( Fixed. Tree parser didn't like (expr).something; fixed. Allowed multiple inheritance in tree grammar. oops. Version 1.16 (August 22, 1999) Extending an interface built a wacky tree: had extra EXTENDS. Tree grammar didn't allow multiple superinterfaces. Tree grammar didn't allow empty var initializer: {} Version 1.17 (October 12, 1999) ESC lexer rule allowed 399 max not 377 max. java.tree.g didn't handle the expression of synchronized statements. Version 1.18 (August 12, 2001) Terence updated to Java 2 Version 1.3 by observing/combining work of Allan Jacobs and Steve Messick. Handles 1.3 src. Summary: o primary didn't include boolean.class kind of thing o constructor calls parsed explicitly now: see explicitConstructorInvocation o add strictfp modifier o missing objBlock after new expression in tree grammar o merged local class definition alternatives, moved after declaration o fixed problem with ClassName.super.field o reordered some alternatives to make things more efficient o long and double constants were not differentiated from int/float o whitespace rule was inefficient: matched only one char o add an examples directory with some nasty 1.3 cases o made Main.java use buffered IO and a Reader for Unicode support o supports UNICODE? Using Unicode charVocabulary makes code file big, but only in the bitsets at the end. I need to make ANTLR generate unicode bitsets more efficiently. Version 1.19 (April 25, 2002) Terence added in nice fixes by John Pybus concerning floating constants and problems with super() calls. John did a nice reorg of the primary/postfix expression stuff to read better and makes f.g.super() parse properly (it was METHOD_CALL not a SUPER_CTOR_CALL). Also: o "finally" clause was a root...made it a child of "try" o Added stuff for asserts too for Java 1.4, but *commented out* as it is not backward compatible. Version 1.20 (October 27, 2002) Terence ended up reorging John Pybus' stuff to remove some nondeterminisms and some syntactic predicates. Note that the grammar is stricter now; e.g., this(...) must be the first statement. Trinary ?: operator wasn't working as array name: (isBig ? bigDigits : digits)[i]; Checked parser/tree parser on source for Resin-2.0.5, jive-2.1.1, jdk 1.3.1, Lucene, antlr 2.7.2a4, and the 110k-line jGuru server source. Version 1.21 (October 17, 2003) Fixed lots of problems including: Ray Waldin: add typeDefinition to interfaceBlock in java.tree.g He found a problem/fix with floating point that start with 0 Ray also fixed problem that (int.class) was not recognized. Thorsten van Ellen noticed that \n are allowed incorrectly in strings. TJP fixed CHAR_LITERAL analogously. Version 1.21.2 (March, 2003) Changes by Matt Quail to support generics (as per JDK1.5/JSR14) Notes: o We only allow the "extends" keyword and not the "implements" keyword, since that's what JSR14 seems to imply. o Thanks to Monty Zukowski for his help on the antlr-interest mail list. o Thanks to Alan Eliasen for testing the grammar over his Fink source base Version 1.22 (July, 2004) Changes by Michael Studman to support Java 1.5 language extensions Notes: o Added support for annotations types o Finished off Matt Quail's generics enhancements to support bound type arguments o Added support for new for statement syntax o Added support for static import syntax o Added support for enum types o Tested against JDK 1.5 source base and source base of jdigraph project o Thanks to Matt Quail for doing the hard part by doing most of the generics work Version 1.22.1 (July 28, 2004) Bug/omission fixes for Java 1.5 language support o Fixed tree structure bug with classOrInterface - thanks to Pieter Vangorpto for spotting this o Fixed bug where incorrect handling of SR and BSR tokens would cause type parameters to be recognised as type arguments. o Enabled type parameters on constructors, annotations on enum constants and package definitions o Fixed problems when parsing if ((char.class.equals(c))) {} - solution by Matt Quail at Cenqua Version 1.22.2 (July 28, 2004) Slight refactoring of Java 1.5 language support o Refactored for/"foreach" productions so that original literal "for" literal is still used but the for sub-clauses vary by token type o Fixed bug where type parameter was not included in generic constructor's branch of AST Version 1.22.3 (August 26, 2004) Bug fixes as identified by Michael Stahl; clean up of tabs/spaces and other refactorings o Fixed typeParameters omission in identPrimary and newStatement o Replaced GT reconcilliation code with simple semantic predicate o Adapted enum/assert keyword checking support from Michael Stahl's java15 grammar o Refactored typeDefinition production and field productions to reduce duplication Version 1.22.4 (October 21, 2004) Small bux fixes o Added typeArguments to explicitConstructorInvocation, e.g. new MyParameterised() o Added typeArguments to postfixExpression productions for anonymous inner class super constructor invocation, e.g. new Outer().super() o Fixed bug in array declarations identified by Geoff Roy Version 1.22.4.g.1 o I have taken java.g for Java1.5 from Michael Studman (1.22.4) and have applied the groovy.diff from java.g (1.22) by John Rose back onto the new root (1.22.4) - Jeremy Rayner (Jan 2005) Version 1.22.4.g.2 o mkempf, rkleeb, Dec 2007 o fixed various rules so that they call the correct Create Method to make sure that the line information are correct Based on an original grammar released in the PUBLIC DOMAIN

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String[]` | `_tokenNames`
    `static BitSet` | `_tokenSet_0`
    `static BitSet` | `_tokenSet_1`
    `static BitSet` | `_tokenSet_10`
    `static BitSet` | `_tokenSet_100`
    `static BitSet` | `_tokenSet_101`
    `static BitSet` | `_tokenSet_102`
    `static BitSet` | `_tokenSet_103`
    `static BitSet` | `_tokenSet_104`
    `static BitSet` | `_tokenSet_105`
    `static BitSet` | `_tokenSet_106`
    `static BitSet` | `_tokenSet_107`
    `static BitSet` | `_tokenSet_108`
    `static BitSet` | `_tokenSet_109`
    `static BitSet` | `_tokenSet_11`
    `static BitSet` | `_tokenSet_110`
    `static BitSet` | `_tokenSet_111`
    `static BitSet` | `_tokenSet_12`
    `static BitSet` | `_tokenSet_13`
    `static BitSet` | `_tokenSet_14`
    `static BitSet` | `_tokenSet_15`
    `static BitSet` | `_tokenSet_16`
    `static BitSet` | `_tokenSet_17`
    `static BitSet` | `_tokenSet_18`
    `static BitSet` | `_tokenSet_19`
    `static BitSet` | `_tokenSet_2`
    `static BitSet` | `_tokenSet_20`
    `static BitSet` | `_tokenSet_21`
    `static BitSet` | `_tokenSet_22`
    `static BitSet` | `_tokenSet_23`
    `static BitSet` | `_tokenSet_24`
    `static BitSet` | `_tokenSet_25`
    `static BitSet` | `_tokenSet_26`
    `static BitSet` | `_tokenSet_27`
    `static BitSet` | `_tokenSet_28`
    `static BitSet` | `_tokenSet_29`
    `static BitSet` | `_tokenSet_3`
    `static BitSet` | `_tokenSet_30`
    `static BitSet` | `_tokenSet_31`
    `static BitSet` | `_tokenSet_32`
    `static BitSet` | `_tokenSet_33`
    `static BitSet` | `_tokenSet_34`
    `static BitSet` | `_tokenSet_35`
    `static BitSet` | `_tokenSet_36`
    `static BitSet` | `_tokenSet_37`
    `static BitSet` | `_tokenSet_38`
    `static BitSet` | `_tokenSet_39`
    `static BitSet` | `_tokenSet_4`
    `static BitSet` | `_tokenSet_40`
    `static BitSet` | `_tokenSet_41`
    `static BitSet` | `_tokenSet_42`
    `static BitSet` | `_tokenSet_43`
    `static BitSet` | `_tokenSet_44`
    `static BitSet` | `_tokenSet_45`
    `static BitSet` | `_tokenSet_46`
    `static BitSet` | `_tokenSet_47`
    `static BitSet` | `_tokenSet_48`
    `static BitSet` | `_tokenSet_49`
    `static BitSet` | `_tokenSet_5`
    `static BitSet` | `_tokenSet_50`
    `static BitSet` | `_tokenSet_51`
    `static BitSet` | `_tokenSet_52`
    `static BitSet` | `_tokenSet_53`
    `static BitSet` | `_tokenSet_54`
    `static BitSet` | `_tokenSet_55`
    `static BitSet` | `_tokenSet_56`
    `static BitSet` | `_tokenSet_57`
    `static BitSet` | `_tokenSet_58`
    `static BitSet` | `_tokenSet_59`
    `static BitSet` | `_tokenSet_6`
    `static BitSet` | `_tokenSet_60`
    `static BitSet` | `_tokenSet_61`
    `static BitSet` | `_tokenSet_62`
    `static BitSet` | `_tokenSet_63`
    `static BitSet` | `_tokenSet_64`
    `static BitSet` | `_tokenSet_65`
    `static BitSet` | `_tokenSet_66`
    `static BitSet` | `_tokenSet_67`
    `static BitSet` | `_tokenSet_68`
    `static BitSet` | `_tokenSet_69`
    `static BitSet` | `_tokenSet_7`
    `static BitSet` | `_tokenSet_70`
    `static BitSet` | `_tokenSet_71`
    `static BitSet` | `_tokenSet_72`
    `static BitSet` | `_tokenSet_73`
    `static BitSet` | `_tokenSet_74`
    `static BitSet` | `_tokenSet_75`
    `static BitSet` | `_tokenSet_76`
    `static BitSet` | `_tokenSet_77`
    `static BitSet` | `_tokenSet_78`
    `static BitSet` | `_tokenSet_79`
    `static BitSet` | `_tokenSet_8`
    `static BitSet` | `_tokenSet_80`
    `static BitSet` | `_tokenSet_81`
    `static BitSet` | `_tokenSet_82`
    `static BitSet` | `_tokenSet_83`
    `static BitSet` | `_tokenSet_84`
    `static BitSet` | `_tokenSet_85`
    `static BitSet` | `_tokenSet_86`
    `static BitSet` | `_tokenSet_87`
    `static BitSet` | `_tokenSet_88`
    `static BitSet` | `_tokenSet_89`
    `static BitSet` | `_tokenSet_9`
    `static BitSet` | `_tokenSet_90`
    `static BitSet` | `_tokenSet_91`
    `static BitSet` | `_tokenSet_92`
    `static BitSet` | `_tokenSet_93`
    `static BitSet` | `_tokenSet_94`
    `static BitSet` | `_tokenSet_95`
    `static BitSet` | `_tokenSet_96`
    `static BitSet` | `_tokenSet_97`
    `static BitSet` | `_tokenSet_98`
    `static BitSet` | `_tokenSet_99`
    `static boolean` | `tracing`

    - ### Fields inherited from class antlr.Parser

      `astFactory, inputState, returnAST, tokenNames, tokenTypeToASTClassMap, traceDepth`

    - ### Fields inherited from interface org.codehaus.groovy.antlr.parser.GroovyTokenTypes

      `ABSTRACT, ANNOTATION, ANNOTATION_ARRAY_INIT, ANNOTATION_DEF, ANNOTATION_FIELD_DEF, ANNOTATION_MEMBER_VALUE_PAIR, ANNOTATIONS, ARRAY_DECLARATOR, ASSIGN, AT, BAND, BAND_ASSIGN, BIG_SUFFIX, BLOCK, BNOT, BOR, BOR_ASSIGN, BSR, BSR_ASSIGN, BXOR, BXOR_ASSIGN, CASE_GROUP, CLASS_DEF, CLOSABLE_BLOCK, CLOSABLE_BLOCK_OP, CLOSURE_LIST, COLON, COMMA, COMPARE_TO, CTOR_CALL, CTOR_IDENT, DEC, DIGIT, DIGITS_WITH_UNDERSCORE, DIGITS_WITH_UNDERSCORE_OPT, DIV, DIV_ASSIGN, DOLLAR, DOLLAR_REGEXP_CTOR_END, DOLLAR_REGEXP_LITERAL, DOLLAR_REGEXP_SYMBOL, DOT, DYNAMIC_MEMBER, ELIST, ELVIS_OPERATOR, EMPTY_STAT, ENUM_CONSTANT_DEF, ENUM_DEF, EOF, EQUAL, ESC, ESCAPED_DOLLAR, ESCAPED_SLASH, EXPONENT, EXPR, EXTENDS_CLAUSE, FINAL, FLOAT_SUFFIX, FOR_CONDITION, FOR_EACH_CLAUSE, FOR_IN_ITERABLE, FOR_INIT, FOR_ITERATOR, GE, GT, HEX_DIGIT, IDENT, IDENTICAL, IMPLEMENTS_CLAUSE, IMPLICIT_PARAMETERS, IMPORT, INC, INDEX_OP, INSTANCE_INIT, INTERFACE_DEF, LABELED_ARG, LABELED_STAT, LAND, LBRACK, LCURLY, LE, LETTER, LIST_CONSTRUCTOR, LITERAL_as, LITERAL_assert, LITERAL_boolean, LITERAL_break, LITERAL_byte, LITERAL_case, LITERAL_catch, LITERAL_char, LITERAL_class, LITERAL_continue, LITERAL_def, LITERAL_default, LITERAL_double, LITERAL_else, LITERAL_enum, LITERAL_extends, LITERAL_false, LITERAL_finally, LITERAL_float, LITERAL_for, LITERAL_if, LITERAL_implements, LITERAL_import, LITERAL_in, LITERAL_instanceof, LITERAL_int, LITERAL_interface, LITERAL_long, LITERAL_native, LITERAL_new, LITERAL_null, LITERAL_package, LITERAL_private, LITERAL_protected, LITERAL_public, LITERAL_return, LITERAL_short, LITERAL_static, LITERAL_super, LITERAL_switch, LITERAL_synchronized, LITERAL_this, LITERAL_threadsafe, LITERAL_throw, LITERAL_throws, LITERAL_trait, LITERAL_transient, LITERAL_true, LITERAL_try, LITERAL_void, LITERAL_volatile, LITERAL_while, LNOT, LOR, LPAREN, LT, MAP_CONSTRUCTOR, MEMBER_POINTER, METHOD_CALL, METHOD_DEF, MINUS, MINUS_ASSIGN, ML_COMMENT, MOD, MOD_ASSIGN, MODIFIERS, MULTICATCH, MULTICATCH_TYPES, NLS, NOT_EQUAL, NOT_IDENTICAL, NULL_TREE_LOOKAHEAD, NUM_BIG_DECIMAL, NUM_BIG_INT, NUM_DOUBLE, NUM_FLOAT, NUM_INT, NUM_LONG, OBJBLOCK, ONE_NL, OPTIONAL_DOT, PACKAGE_DEF, PARAMETER_DEF, PARAMETERS, PLUS, PLUS_ASSIGN, POST_DEC, POST_INC, QUESTION, RANGE_EXCLUSIVE, RANGE_INCLUSIVE, RBRACK, RCURLY, REGEX_FIND, REGEX_MATCH, REGEXP_CTOR_END, REGEXP_LITERAL, REGEXP_SYMBOL, RPAREN, SELECT_SLOT, SEMI, SH_COMMENT, SL, SL_ASSIGN, SL_COMMENT, SLIST, SPREAD_ARG, SPREAD_DOT, SPREAD_MAP_ARG, SR, SR_ASSIGN, STAR, STAR_ASSIGN, STAR_STAR, STAR_STAR_ASSIGN, STATIC_IMPORT, STATIC_INIT, STRICTFP, STRING_CH, STRING_CONSTRUCTOR, STRING_CTOR_END, STRING_CTOR_MIDDLE, STRING_CTOR_START, STRING_LITERAL, STRING_NL, SUPER_CTOR_CALL, TRAIT_DEF, TRIPLE_DOT, TYPE, TYPE_ARGUMENT, TYPE_ARGUMENTS, TYPE_LOWER_BOUNDS, TYPE_PARAMETER, TYPE_PARAMETERS, TYPE_UPPER_BOUNDS, TYPECAST, UNARY_MINUS, UNARY_PLUS, UNUSED_CONST, UNUSED_DO, UNUSED_GOTO, VARIABLE_DEF, VARIABLE_PARAMETER_DEF, VOCAB, WILDCARD_TYPE, WS`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `GroovyRecognizer(ParserSharedInputState state)`
    `` | `GroovyRecognizer(TokenBuffer tokenBuf)`
    `protected` | `GroovyRecognizer(TokenBuffer tokenBuf, int k)`
    `` | `GroovyRecognizer(TokenStream lexer)`
    `protected` | `GroovyRecognizer(TokenStream lexer, int k)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `aCase()`
    `void` | `additiveExpression(int lc_stmt)`
    `void` | `addWarning(java.lang.String warning, java.lang.String solution)`
    `void` | `andExpression(int lc_stmt)`
    `void` | `annotation()`
    `void` | `annotationArguments()`
    `void` | `annotationBlock()`
    `void` | `annotationDefinition(AST modifiers)`
    `void` | `annotationField()`
    `void` | `annotationIdent()`
    `void` | `annotationMemberValueInitializer()`
    `void` | `annotationMemberValuePair()`
    `void` | `annotationMemberValuePairs()`
    `void` | `annotationsInternal()`
    `void` | `annotationsOpt()`
    `void` | `appendedBlock(AST callee)` An appended block follows any expression.
    `void` | `argList()`
    `byte` | `argument()` A single argument in (...) or [...].
    `void` | `argumentLabel()` A label for an argument is of the form a:b, 'a':b, "a":b, (a):b, etc..
    `void` | `argumentLabelStart()` For lookahead only.
    `void` | `assignmentExpression(int lc_stmt)`
    `void` | `assignmentLessExpression()`
    `void` | `balancedBrackets()` Fast lookahead across balanced brackets of all sorts.
    `void` | `balancedTokens()`
    `void` | `blockBody(int prevToken)` A block body is a parade of zero or more statements or expressions.
    `void` | `branchStatement()` In Groovy, return, break, continue, throw, and assert can be used in a parenthesized expression context.
    `protected void` | `buildTokenTypeASTClassMap()`
    `void` | `builtInType()`
    `void` | `builtInTypeArraySpec(boolean addImagNode)`
    `void` | `builtInTypeSpec(boolean addImagNode)`
    `void` | `casesGroup()`
    `void` | `caseSList()`
    `void` | `checkSuspiciousExpressionStatement(int prevToken)` If two statements are separated by newline (not SEMI), the second had better not look like the latter half of an expression.
    `void` | `classBlock()`
    `void` | `classDefinition(AST modifiers)`
    `void` | `classField()`
    `void` | `classOrInterfaceType(boolean addImagNode)`
    `void` | `classTypeSpec(boolean addImagNode)`
    `Token` | `cloneToken(Token t)` Clones the token
    `void` | `closableBlock()` A block which is known to be a closure, even if it has no apparent arguments.
    `void` | `closableBlockConstructorExpression()`
    `void` | `closableBlockParam()` Simple names, as in {x|...}, are completely equivalent to {(def x)|...}.
    `void` | `closableBlockParamsOpt(boolean addImplicit)` Closure parameters are exactly like method parameters, except that they are not enclosed in parentheses, but rather are prepended to the front of a block, just after the brace.
    `void` | `closableBlockParamsStart()` Lookahead to check whether a block begins with explicit closure arguments.
    `void` | `closureList()`
    `void` | `commandArgument()`
    `void` | `commandArguments(AST head)` A member name (x.y) or element name (x[y]) can serve as a command name, which may be followed by a list of arguments.
    `void` | `commandArgumentsGreedy(AST head)`
    `void` | `compatibleBodyStatement()` In Java, "if", "while", and "for" statements can take random, non-braced statements as their bodies.
    `void` | `compilationUnit()`
    `void` | `compoundStatement()`
    `void` | `conditionalExpression(int lc_stmt)`
    `void` | `constant()` Numeric, string, regexp, boolean, or null constant.
    `void` | `constantNumber()` Numeric constant.
    `void` | `constructorBody()`
    `void` | `constructorDefinition(AST mods)` I've split out constructors separately; we could maybe integrate back into variableDefinitions later on if we maybe simplified 'def' to be a type declaration?
    `void` | `constructorStart()` Used to look ahead for a constructor
    `void` | `controlExpressionList()`
    `AST` | `create(int type, java.lang.String txt, AST first)` Create an AST node with the token type and text passed in, but with the same background information as another supplied Token (e.g. line numbers).
    `AST` | `create(int type, java.lang.String txt, AST first, AST last)`
    `AST` | `create(int type, java.lang.String txt, AST first, Token last)`
    `AST` | `create(int type, java.lang.String txt, Token first, Token last)`
    `void` | `declaration()` A declaration is the creation of a reference or primitive-type variable, or (if arguments are present) of a method.
    `void` | `declarationStart()` Used only as a lookahead predicate, before diving in and parsing a declaration.
    `void` | `declaratorBrackets(AST typ)` After some type names, where zero or more empty bracket pairs are allowed.
    `void` | `dynamicMemberName()` If a dot is followed by a parenthesized or quoted expression, the member is computed dynamically, and the member selection is done only at runtime.
    `void` | `enumBlock()`
    `void` | `enumConstant()`
    `void` | `enumConstantBlock()`
    `void` | `enumConstantField()`
    `protected void` | `enumConstantFieldInternal(AST mods, AST tp, AST t, Token first)`
    `void` | `enumConstants()` Comma-separated list of one or more enum constant definitions.
    `void` | `enumConstantsStart()` Guard for enumConstants.
    `void` | `enumDefinition(AST modifiers)`
    `void` | `equalityExpression(int lc_stmt)`
    `void` | `exclusiveOrExpression(int lc_stmt)`
    `void` | `explicitConstructorInvocation()` Catch obvious constructor calls, but not the expr.super(...) calls
    `void` | `expression(int lc_stmt)`
    `void` | `expressionStatement(int prevToken)` An expression statement can be any general expression.
    `void` | `expressionStatementNoCheck()`
    `void` | `finallyClause()`
    `void` | `forCond()`
    `void` | `forInClause()`
    `void` | `forInit()`
    `void` | `forIter()`
    `void` | `forStatement()`
    `void` | `genericMethod()`
    `void` | `genericMethodStart()` lookahead predicate for usage of generics in methods as parameter for the method.
    `GroovyLexer` | `getLexer()`
    `java.util.List` | `getWarningList()`
    `void` | `handler()`
    `void` | `identifier()`
    `void` | `identifierStar()`
    `void` | `implementsClause()`
    `void` | `implicitParameters()` A block known to be a closure, but which omits its arguments, is given this placeholder.
    `void` | `importStatement()`
    `void` | `inclusiveOrExpression(int lc_stmt)`
    `void` | `indexPropertyArgs(AST indexee)` An expression may be followed by [...].
    `void` | `interfaceBlock()`
    `void` | `interfaceDefinition(AST modifiers)`
    `void` | `interfaceExtends()`
    `void` | `interfaceField()`
    `void` | `keywordPropertyNames()`
    `void` | `listOfVariables(AST mods, AST t, Token first)`
    `void` | `listOrMapConstructorExpression()` A list constructor is a argument list enclosed in square brackets, without labels.
    `void` | `logicalAndExpression(int lc_stmt)`
    `void` | `logicalOrExpression(int lc_stmt)`
    `static GroovyRecognizer` | `make(GroovyLexer lexer)` This factory is the correct way to wire together a Groovy parser and lexer.
    `static GroovyRecognizer` | `make(InputBuffer in)`
    `static GroovyRecognizer` | `make(java.io.InputStream in)`
    `static GroovyRecognizer` | `make(LexerSharedInputState in)`
    `static GroovyRecognizer` | `make(java.io.Reader in)`
    `void` | `matchGenericTypeBracketsFailed(java.lang.String problem, java.lang.String solution)`
    `void` | `methodCallArgs(AST callee)` An expression may be followed by one or both of (...) and {...}.
    `void` | `modifier()`
    `void` | `modifiers()` A list of one or more modifier, annotation, or "def".
    `void` | `modifiersInternal()`
    `void` | `modifiersOpt()` A list of zero or more modifiers, annotations, or "def".
    `void` | `multicatch_types()`
    `void` | `multicatch()`
    `void` | `multipleAssignment(int lc_stmt)`
    `void` | `multipleAssignmentDeclaration()`
    `void` | `multipleAssignmentDeclarationStart()`
    `void` | `multiplicativeExpression(int lc_stmt)`
    `void` | `namePart()` This is the grammar for what can follow a dot: x.a, x.@a, x.&a, x.'a', etc.
    `void` | `newArrayDeclarator()`
    `void` | `newExpression()` object instantiation.
    `void` | `nls()` Zero or more insignificant newlines, all gobbled up and thrown away.
    `void` | `nlsWarn()` Zero or more insignificant newlines, all gobbled up and thrown away, but a warning message is left for the user, if there was a newline.
    `void` | `openBlock()` An open block is not allowed to have closure arguments.
    `void` | `openOrClosableBlock()` A sub-block of a block can be either open or closable.
    `void` | `packageDefinition()`
    `void` | `parameterDeclaration()` A formal parameter for a method or closure.
    `void` | `parameterDeclarationList()` A list of zero or more formal parameters.
    `void` | `parameterModifiersOpt()`
    `void` | `parenthesizedExpression()`
    `void` | `pathChain(int lc_stmt, AST prefix)`
    `void` | `pathElement(AST prefix)`
    `void` | `pathElementStart()`
    `void` | `pathExpression(int lc_stmt)` A "path expression" is a name or other primary, possibly qualified by various forms of dot, and/or followed by various kinds of brackets.
    `void` | `postfixExpression(int lc_stmt)`
    `void` | `powerExpression(int lc_stmt)`
    `void` | `powerExpressionNotPlusMinus(int lc_stmt)`
    `void` | `primaryExpression()`
    `void` | `qualifiedTypeName()`
    `void` | `regexExpression(int lc_stmt)`
    `void` | `relationalExpression(int lc_stmt)`
    `void` | `requireFailed(java.lang.String problem, java.lang.String solution)`
    `void` | `sep()` A statement separator is either a semicolon or a significant newline.
    `void` | `setFilename(java.lang.String f)`
    `void` | `setSourceBuffer(SourceBuffer sourceBuffer)`
    `void` | `shiftExpression(int lc_stmt)`
    `void` | `singleDeclaration()` A declaration with one declarator and optional initialization, like a parameterDeclaration.
    `void` | `singleDeclarationNoInit()` A declaration with one declarator and no initialization, like a parameterDeclaration.
    `void` | `singleVariable(AST mods, AST t)` Used in cases where a declaration cannot have commas, or ends with the "in" operator instead of '='.
    `void` | `snippetUnit()` A Groovy script or simple expression.
    `void` | `statement(int prevToken)` A statement is an element of a block.
    `void` | `statementLabelPrefix()` A labeled statement, consisting of a vanilla identifier followed by a colon.
    `boolean` | `strictContextExpression(boolean allowDeclaration)` Things that can show up as expressions, but only in strict contexts like inside parentheses, argument lists, and list constructors.
    `void` | `stringConstructorExpression()`
    `void` | `stringConstructorValuePart()`
    `void` | `superClassClause()`
    `void` | `suspiciousExpressionStatementStart()` Lookahead for suspicious statement warnings and errors.
    `void` | `throwsClause()`
    `void` | `traceIn(java.lang.String rname)`
    `void` | `traceOut(java.lang.String rname)`
    `void` | `traitDefinition(AST modifiers)`
    `void` | `tryBlock()`
    `void` | `type()`
    `void` | `typeArgument()`
    `void` | `typeArgumentBounds()`
    `void` | `typeArguments()`
    `void` | `typeArgumentsDiamond()`
    `protected void` | `typeArgumentsOrParametersEnd()`
    `void` | `typeArgumentSpec()`
    `void` | `typeDeclarationStart()` Used only as a lookahead predicate for nested type declarations.
    `protected void` | `typeDefinitionInternal(AST mods)`
    `void` | `typeNamePairs(AST mods, Token first)`
    `void` | `typeParameter()`
    `void` | `typeParameterBounds()`
    `void` | `typeParameters()`
    `void` | `typeSpec(boolean addImagNode)`
    `void` | `unaryExpression(int lc_stmt)`
    `void` | `unaryExpressionNotPlusMinus(int lc_stmt)`
    `void` | `upperCaseIdent()` An IDENT token whose spelling is required to start with an uppercase letter.
    `void` | `variableDeclarator(AST mods, AST t, Token first)` Declaration of a variable.
    `void` | `variableDefinitions(AST mods, AST t)` The tail of a declaration.
    `void` | `variableName()`
    `void` | `varInitializer()` An assignment operator '=' followed by an expression.
    `void` | `wildcardType()`

    - ### Methods inherited from class antlr.LLkParser

      `consume, LA, LT`

    - ### Methods inherited from class antlr.Parser

      `addMessageListener, addParserListener, addParserMatchListener, addParserTokenListener, addSemanticPredicateListener, addSyntacticPredicateListener, addTraceListener, consumeUntil, consumeUntil, defaultDebuggingSetup, getAST, getASTFactory, getFilename, getInputState, getTokenName, getTokenNames, getTokenTypeToASTClassMap, isDebugMode, mark, match, match, matchNot, panic, recover, removeMessageListener, removeParserListener, removeParserMatchListener, removeParserTokenListener, removeSemanticPredicateListener, removeSyntacticPredicateListener, removeTraceListener, reportError, reportError, reportWarning, rewind, setASTFactory, setASTNodeClass, setASTNodeType, setDebugMode, setIgnoreInvalidDebugCalls, setInputState, setTokenBuffer, traceIndent`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### tracing

          public static boolean tracing

    - #### _tokenNames

          public static final java.lang.String[] _tokenNames

    - #### _tokenSet_0

          public static final BitSet _tokenSet_0

    - #### _tokenSet_1

          public static final BitSet _tokenSet_1

    - #### _tokenSet_2

          public static final BitSet _tokenSet_2

    - #### _tokenSet_3

          public static final BitSet _tokenSet_3

    - #### _tokenSet_4

          public static final BitSet _tokenSet_4

    - #### _tokenSet_5

          public static final BitSet _tokenSet_5

    - #### _tokenSet_6

          public static final BitSet _tokenSet_6

    - #### _tokenSet_7

          public static final BitSet _tokenSet_7

    - #### _tokenSet_8

          public static final BitSet _tokenSet_8

    - #### _tokenSet_9

          public static final BitSet _tokenSet_9

    - #### _tokenSet_10

          public static final BitSet _tokenSet_10

    - #### _tokenSet_11

          public static final BitSet _tokenSet_11

    - #### _tokenSet_12

          public static final BitSet _tokenSet_12

    - #### _tokenSet_13

          public static final BitSet _tokenSet_13

    - #### _tokenSet_14

          public static final BitSet _tokenSet_14

    - #### _tokenSet_15

          public static final BitSet _tokenSet_15

    - #### _tokenSet_16

          public static final BitSet _tokenSet_16

    - #### _tokenSet_17

          public static final BitSet _tokenSet_17

    - #### _tokenSet_18

          public static final BitSet _tokenSet_18

    - #### _tokenSet_19

          public static final BitSet _tokenSet_19

    - #### _tokenSet_20

          public static final BitSet _tokenSet_20

    - #### _tokenSet_21

          public static final BitSet _tokenSet_21

    - #### _tokenSet_22

          public static final BitSet _tokenSet_22

    - #### _tokenSet_23

          public static final BitSet _tokenSet_23

    - #### _tokenSet_24

          public static final BitSet _tokenSet_24

    - #### _tokenSet_25

          public static final BitSet _tokenSet_25

    - #### _tokenSet_26

          public static final BitSet _tokenSet_26

    - #### _tokenSet_27

          public static final BitSet _tokenSet_27

    - #### _tokenSet_28

          public static final BitSet _tokenSet_28

    - #### _tokenSet_29

          public static final BitSet _tokenSet_29

    - #### _tokenSet_30

          public static final BitSet _tokenSet_30

    - #### _tokenSet_31

          public static final BitSet _tokenSet_31

    - #### _tokenSet_32

          public static final BitSet _tokenSet_32

    - #### _tokenSet_33

          public static final BitSet _tokenSet_33

    - #### _tokenSet_34

          public static final BitSet _tokenSet_34

    - #### _tokenSet_35

          public static final BitSet _tokenSet_35

    - #### _tokenSet_36

          public static final BitSet _tokenSet_36

    - #### _tokenSet_37

          public static final BitSet _tokenSet_37

    - #### _tokenSet_38

          public static final BitSet _tokenSet_38

    - #### _tokenSet_39

          public static final BitSet _tokenSet_39

    - #### _tokenSet_40

          public static final BitSet _tokenSet_40

    - #### _tokenSet_41

          public static final BitSet _tokenSet_41

    - #### _tokenSet_42

          public static final BitSet _tokenSet_42

    - #### _tokenSet_43

          public static final BitSet _tokenSet_43

    - #### _tokenSet_44

          public static final BitSet _tokenSet_44

    - #### _tokenSet_45

          public static final BitSet _tokenSet_45

    - #### _tokenSet_46

          public static final BitSet _tokenSet_46

    - #### _tokenSet_47

          public static final BitSet _tokenSet_47

    - #### _tokenSet_48

          public static final BitSet _tokenSet_48

    - #### _tokenSet_49

          public static final BitSet _tokenSet_49

    - #### _tokenSet_50

          public static final BitSet _tokenSet_50

    - #### _tokenSet_51

          public static final BitSet _tokenSet_51

    - #### _tokenSet_52

          public static final BitSet _tokenSet_52

    - #### _tokenSet_53

          public static final BitSet _tokenSet_53

    - #### _tokenSet_54

          public static final BitSet _tokenSet_54

    - #### _tokenSet_55

          public static final BitSet _tokenSet_55

    - #### _tokenSet_56

          public static final BitSet _tokenSet_56

    - #### _tokenSet_57

          public static final BitSet _tokenSet_57

    - #### _tokenSet_58

          public static final BitSet _tokenSet_58

    - #### _tokenSet_59

          public static final BitSet _tokenSet_59

    - #### _tokenSet_60

          public static final BitSet _tokenSet_60

    - #### _tokenSet_61

          public static final BitSet _tokenSet_61

    - #### _tokenSet_62

          public static final BitSet _tokenSet_62

    - #### _tokenSet_63

          public static final BitSet _tokenSet_63

    - #### _tokenSet_64

          public static final BitSet _tokenSet_64

    - #### _tokenSet_65

          public static final BitSet _tokenSet_65

    - #### _tokenSet_66

          public static final BitSet _tokenSet_66

    - #### _tokenSet_67

          public static final BitSet _tokenSet_67

    - #### _tokenSet_68

          public static final BitSet _tokenSet_68

    - #### _tokenSet_69

          public static final BitSet _tokenSet_69

    - #### _tokenSet_70

          public static final BitSet _tokenSet_70

    - #### _tokenSet_71

          public static final BitSet _tokenSet_71

    - #### _tokenSet_72

          public static final BitSet _tokenSet_72

    - #### _tokenSet_73

          public static final BitSet _tokenSet_73

    - #### _tokenSet_74

          public static final BitSet _tokenSet_74

    - #### _tokenSet_75

          public static final BitSet _tokenSet_75

    - #### _tokenSet_76

          public static final BitSet _tokenSet_76

    - #### _tokenSet_77

          public static final BitSet _tokenSet_77

    - #### _tokenSet_78

          public static final BitSet _tokenSet_78

    - #### _tokenSet_79

          public static final BitSet _tokenSet_79

    - #### _tokenSet_80

          public static final BitSet _tokenSet_80

    - #### _tokenSet_81

          public static final BitSet _tokenSet_81

    - #### _tokenSet_82

          public static final BitSet _tokenSet_82

    - #### _tokenSet_83

          public static final BitSet _tokenSet_83

    - #### _tokenSet_84

          public static final BitSet _tokenSet_84

    - #### _tokenSet_85

          public static final BitSet _tokenSet_85

    - #### _tokenSet_86

          public static final BitSet _tokenSet_86

    - #### _tokenSet_87

          public static final BitSet _tokenSet_87

    - #### _tokenSet_88

          public static final BitSet _tokenSet_88

    - #### _tokenSet_89

          public static final BitSet _tokenSet_89

    - #### _tokenSet_90

          public static final BitSet _tokenSet_90

    - #### _tokenSet_91

          public static final BitSet _tokenSet_91

    - #### _tokenSet_92

          public static final BitSet _tokenSet_92

    - #### _tokenSet_93

          public static final BitSet _tokenSet_93

    - #### _tokenSet_94

          public static final BitSet _tokenSet_94

    - #### _tokenSet_95

          public static final BitSet _tokenSet_95

    - #### _tokenSet_96

          public static final BitSet _tokenSet_96

    - #### _tokenSet_97

          public static final BitSet _tokenSet_97

    - #### _tokenSet_98

          public static final BitSet _tokenSet_98

    - #### _tokenSet_99

          public static final BitSet _tokenSet_99

    - #### _tokenSet_100

          public static final BitSet _tokenSet_100

    - #### _tokenSet_101

          public static final BitSet _tokenSet_101

    - #### _tokenSet_102

          public static final BitSet _tokenSet_102

    - #### _tokenSet_103

          public static final BitSet _tokenSet_103

    - #### _tokenSet_104

          public static final BitSet _tokenSet_104

    - #### _tokenSet_105

          public static final BitSet _tokenSet_105

    - #### _tokenSet_106

          public static final BitSet _tokenSet_106

    - #### _tokenSet_107

          public static final BitSet _tokenSet_107

    - #### _tokenSet_108

          public static final BitSet _tokenSet_108

    - #### _tokenSet_109

          public static final BitSet _tokenSet_109

    - #### _tokenSet_110

          public static final BitSet _tokenSet_110

    - #### _tokenSet_111

          public static final BitSet _tokenSet_111

  - ### Constructor Detail

    - #### GroovyRecognizer

          protected GroovyRecognizer(TokenBuffer tokenBuf,
                                     int k)

    - #### GroovyRecognizer

          public GroovyRecognizer(TokenBuffer tokenBuf)

    - #### GroovyRecognizer

          protected GroovyRecognizer(TokenStream lexer,
                                     int k)

    - #### GroovyRecognizer

          public GroovyRecognizer(TokenStream lexer)

    - #### GroovyRecognizer

          public GroovyRecognizer(ParserSharedInputState state)

  - ### Method Detail

    - #### make

          public static GroovyRecognizer make(GroovyLexer lexer)

      This factory is the correct way to wire together a Groovy parser and lexer.

    - #### make

          public static GroovyRecognizer make(java.io.InputStream in)

    - #### make

          public static GroovyRecognizer make(java.io.Reader in)

    - #### make

          public static GroovyRecognizer make(InputBuffer in)

    - #### make

          public static GroovyRecognizer make(LexerSharedInputState in)

    - #### getWarningList

          public java.util.List getWarningList()

    - #### getLexer

          public GroovyLexer getLexer()

    - #### setFilename

          public void setFilename(java.lang.String f)

      Overrides:
        `setFilename` in class `Parser`

    - #### setSourceBuffer

          public void setSourceBuffer(SourceBuffer sourceBuffer)

    - #### create

          public AST create(int type,
                            java.lang.String txt,
                            AST first)

      Create an AST node with the token type and text passed in, but with the same background information as another supplied Token (e.g. line numbers). To be used in place of antlr tree construction syntax, i.e. #[TOKEN,"text"] becomes create(TOKEN,"text",anotherToken) todo - change antlr.ASTFactory to do this instead...

    - #### create

          public AST create(int type,
                            java.lang.String txt,
                            Token first,
                            Token last)

    - #### create

          public AST create(int type,
                            java.lang.String txt,
                            AST first,
                            Token last)

    - #### create

          public AST create(int type,
                            java.lang.String txt,
                            AST first,
                            AST last)

    - #### cloneToken

          public Token cloneToken(Token t)

      Clones the token

    - #### traceIn

          public void traceIn(java.lang.String rname)
                       throws TokenStreamException

      Overrides:
        `traceIn` in class `LLkParser`
      Throws:
        `TokenStreamException`

    - #### traceOut

          public void traceOut(java.lang.String rname)
                        throws TokenStreamException

      Overrides:
        `traceOut` in class `LLkParser`
      Throws:
        `TokenStreamException`

    - #### requireFailed

          public void requireFailed(java.lang.String problem,
                                    java.lang.String solution)
                             throws SemanticException

      Throws:
        `SemanticException`

    - #### addWarning

          public void addWarning(java.lang.String warning,
                                 java.lang.String solution)

    - #### matchGenericTypeBracketsFailed

          public void matchGenericTypeBracketsFailed(java.lang.String problem,
                                                     java.lang.String solution)
                                              throws SemanticException

      Throws:
        `SemanticException`

    - #### compilationUnit

          public final void compilationUnit()
                                     throws RecognitionException,
                                            TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### nls

          public final void nls()
                         throws RecognitionException,
                                TokenStreamException

      Zero or more insignificant newlines, all gobbled up and thrown away.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### annotationsOpt

          public final void annotationsOpt()
                                    throws RecognitionException,
                                           TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### packageDefinition

          public final void packageDefinition()
                                       throws RecognitionException,
                                              TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### statement

          public final void statement(int prevToken)
                               throws RecognitionException,
                                      TokenStreamException

      A statement is an element of a block. Typical statements are declarations (which are scoped to the block) and expressions.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### sep

          public final void sep()
                         throws RecognitionException,
                                TokenStreamException

      A statement separator is either a semicolon or a significant newline. Any number of additional (insignificant) newlines may accompany it.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### snippetUnit

          public final void snippetUnit()
                                 throws RecognitionException,
                                        TokenStreamException

      A Groovy script or simple expression. Can be anything legal inside {...}.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### blockBody

          public final void blockBody(int prevToken)
                               throws RecognitionException,
                                      TokenStreamException

      A block body is a parade of zero or more statements or expressions.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### identifier

          public final void identifier()
                                throws RecognitionException,
                                       TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### importStatement

          public final void importStatement()
                                     throws RecognitionException,
                                            TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### identifierStar

          public final void identifierStar()
                                    throws RecognitionException,
                                           TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### typeDefinitionInternal

          protected final void typeDefinitionInternal(AST mods)
                                               throws RecognitionException,
                                                      TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### classDefinition

          public final void classDefinition(AST modifiers)
                                     throws RecognitionException,
                                            TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### traitDefinition

          public final void traitDefinition(AST modifiers)
                                     throws RecognitionException,
                                            TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### interfaceDefinition

          public final void interfaceDefinition(AST modifiers)
                                         throws RecognitionException,
                                                TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### enumDefinition

          public final void enumDefinition(AST modifiers)
                                    throws RecognitionException,
                                           TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### annotationDefinition

          public final void annotationDefinition(AST modifiers)
                                          throws RecognitionException,
                                                 TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### declaration

          public final void declaration()
                                 throws RecognitionException,
                                        TokenStreamException

      A declaration is the creation of a reference or primitive-type variable, or (if arguments are present) of a method. Generically, this is called a 'variable' definition, even in the case of a class field or method. It may start with the modifiers and/or a declaration keyword "def". It may also start with the modifiers and a capitalized type name.

      AST effect: Create a separate Type/Var tree for each var in the var list. Must be guarded, as in (declarationStart) => declaration.

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### modifiers

          public final void modifiers()
                               throws RecognitionException,
                                      TokenStreamException

      A list of one or more modifier, annotation, or "def".
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### typeSpec

          public final void typeSpec(boolean addImagNode)
                              throws RecognitionException,
                                     TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### variableDefinitions

          public final void variableDefinitions(AST mods,
                                                AST t)
                                         throws RecognitionException,
                                                TokenStreamException

      The tail of a declaration. Either v1, v2, ... (with possible initializers) or else m(args){body}. The two arguments are the modifier list (if any) and the declaration head (if any). The declaration head is the variable type, or (for a method) the return type. If it is missing, then the variable type is taken from its initializer (if there is one). Otherwise, the variable type defaults to 'any'. DECIDE: Method return types default to the type of the method body, as an expression.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### genericMethod

          public final void genericMethod()
                                   throws RecognitionException,
                                          TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### typeParameters

          public final void typeParameters()
                                    throws RecognitionException,
                                           TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### singleDeclarationNoInit

          public final void singleDeclarationNoInit()
                                             throws RecognitionException,
                                                    TokenStreamException

      A declaration with one declarator and no initialization, like a parameterDeclaration. Used to parse loops like `for (int x in y)` (up to the `in` keyword).
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### singleVariable

          public final void singleVariable(AST mods,
                                           AST t)
                                    throws RecognitionException,
                                           TokenStreamException

      Used in cases where a declaration cannot have commas, or ends with the "in" operator instead of '='.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### singleDeclaration

          public final void singleDeclaration()
                                       throws RecognitionException,
                                              TokenStreamException

      A declaration with one declarator and optional initialization, like a parameterDeclaration. Used to parse declarations used for both binding and effect, in places like argument lists and `while` statements.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### varInitializer

          public final void varInitializer()
                                    throws RecognitionException,
                                           TokenStreamException

      An assignment operator '=' followed by an expression. (Never empty.)
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### declarationStart

          public final void declarationStart()
                                      throws RecognitionException,
                                             TokenStreamException

      Used only as a lookahead predicate, before diving in and parsing a declaration. A declaration can be unambiguously introduced with "def", an annotation or a modifier token like "final". It may also be introduced by a simple identifier whose first character is an uppercase letter, as in {String x}. A declaration can also be introduced with a built in type like 'int' or 'void'. Brackets (array and generic) are allowed, as in {List[] x} or {int[][] y}. Anything else is parsed as a statement of some sort (expression or command).

      (In the absence of explicit method-call parens, we assume a capitalized name is a type name. Yes, this is a little hacky. Alternatives are to complicate the declaration or command syntaxes, or to have the parser query the symbol table. Parse-time queries are evil. And we want both {String x} and {println x}. So we need a syntactic razor-edge to slip between 'println' and 'String'.) *TODO* The declarationStart production needs to be strengthened to recognize things like {List foo}. Right now it only knows how to skip square brackets after the type, not angle brackets. This probably turns out to be tricky because of >> vs. > >. If so, just put a TODO comment in.

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### modifier

          public final void modifier()
                              throws RecognitionException,
                                     TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### annotation

          public final void annotation()
                                throws RecognitionException,
                                       TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### upperCaseIdent

          public final void upperCaseIdent()
                                    throws RecognitionException,
                                           TokenStreamException

      An IDENT token whose spelling is required to start with an uppercase letter. In the case of a simple statement {UpperID name} the identifier is taken to be a type name, not a command name.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### builtInType

          public final void builtInType()
                                 throws RecognitionException,
                                        TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### qualifiedTypeName

          public final void qualifiedTypeName()
                                       throws RecognitionException,
                                              TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### typeArguments

          public final void typeArguments()
                                   throws RecognitionException,
                                          TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### balancedTokens

          public final void balancedTokens()
                                    throws RecognitionException,
                                           TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### genericMethodStart

          public final void genericMethodStart()
                                        throws RecognitionException,
                                               TokenStreamException

      lookahead predicate for usage of generics in methods as parameter for the method. Example: static T foo(){} must be first after the modifier. This rule allows more and does no exact match, but it is only a lookahead, not the real rule.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### constructorStart

          public final void constructorStart()
                                      throws RecognitionException,
                                             TokenStreamException

      Used to look ahead for a constructor
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### modifiersOpt

          public final void modifiersOpt()
                                  throws RecognitionException,
                                         TokenStreamException

      A list of zero or more modifiers, annotations, or "def".
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### typeDeclarationStart

          public final void typeDeclarationStart()
                                          throws RecognitionException,
                                                 TokenStreamException

      Used only as a lookahead predicate for nested type declarations.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### classTypeSpec

          public final void classTypeSpec(boolean addImagNode)
                                   throws RecognitionException,
                                          TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### builtInTypeSpec

          public final void builtInTypeSpec(boolean addImagNode)
                                     throws RecognitionException,
                                            TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### classOrInterfaceType

          public final void classOrInterfaceType(boolean addImagNode)
                                          throws RecognitionException,
                                                 TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### declaratorBrackets

          public final void declaratorBrackets(AST typ)
                                        throws RecognitionException,
                                               TokenStreamException

      After some type names, where zero or more empty bracket pairs are allowed. We use ARRAY_DECLARATOR to represent this. TODO: Is there some more Groovy way to view this in terms of the indexed property syntax?
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### typeArgumentsDiamond

          public final void typeArgumentsDiamond()
                                          throws RecognitionException,
                                                 TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### typeArgumentSpec

          public final void typeArgumentSpec()
                                      throws RecognitionException,
                                             TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### builtInTypeArraySpec

          public final void builtInTypeArraySpec(boolean addImagNode)
                                          throws RecognitionException,
                                                 TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### typeArgument

          public final void typeArgument()
                                  throws RecognitionException,
                                         TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### wildcardType

          public final void wildcardType()
                                  throws RecognitionException,
                                         TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### typeArgumentBounds

          public final void typeArgumentBounds()
                                        throws RecognitionException,
                                               TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### typeArgumentsOrParametersEnd

          protected final void typeArgumentsOrParametersEnd()
                                                     throws RecognitionException,
                                                            TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### type

          public final void type()
                          throws RecognitionException,
                                 TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### modifiersInternal

          public final void modifiersInternal()
                                       throws RecognitionException,
                                              TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### annotationArguments

          public final void annotationArguments()
                                         throws RecognitionException,
                                                TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### annotationsInternal

          public final void annotationsInternal()
                                         throws RecognitionException,
                                                TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### annotationMemberValueInitializer

          public final void annotationMemberValueInitializer()
                                                      throws RecognitionException,
                                                             TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### annotationMemberValuePairs

          public final void annotationMemberValuePairs()
                                                throws RecognitionException,
                                                       TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### annotationMemberValuePair

          public final void annotationMemberValuePair()
                                               throws RecognitionException,
                                                      TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### annotationIdent

          public final void annotationIdent()
                                     throws RecognitionException,
                                            TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### keywordPropertyNames

          public final void keywordPropertyNames()
                                          throws RecognitionException,
                                                 TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### conditionalExpression

          public final void conditionalExpression(int lc_stmt)
                                           throws RecognitionException,
                                                  TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### superClassClause

          public final void superClassClause()
                                      throws RecognitionException,
                                             TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### implementsClause

          public final void implementsClause()
                                      throws RecognitionException,
                                             TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### classBlock

          public final void classBlock()
                                throws RecognitionException,
                                       TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### interfaceExtends

          public final void interfaceExtends()
                                      throws RecognitionException,
                                             TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### interfaceBlock

          public final void interfaceBlock()
                                    throws RecognitionException,
                                           TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### enumBlock

          public final void enumBlock()
                               throws RecognitionException,
                                      TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### annotationBlock

          public final void annotationBlock()
                                     throws RecognitionException,
                                            TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### typeParameter

          public final void typeParameter()
                                   throws RecognitionException,
                                          TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### typeParameterBounds

          public final void typeParameterBounds()
                                         throws RecognitionException,
                                                TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### classField

          public final void classField()
                                throws RecognitionException,
                                       TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### interfaceField

          public final void interfaceField()
                                    throws RecognitionException,
                                           TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### annotationField

          public final void annotationField()
                                     throws RecognitionException,
                                            TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### enumConstantsStart

          public final void enumConstantsStart()
                                        throws RecognitionException,
                                               TokenStreamException

      Guard for enumConstants.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### enumConstants

          public final void enumConstants()
                                   throws RecognitionException,
                                          TokenStreamException

      Comma-separated list of one or more enum constant definitions.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### enumConstant

          public final void enumConstant()
                                  throws RecognitionException,
                                         TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### argList

          public final void argList()
                             throws RecognitionException,
                                    TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### enumConstantBlock

          public final void enumConstantBlock()
                                       throws RecognitionException,
                                              TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### enumConstantField

          public final void enumConstantField()
                                       throws RecognitionException,
                                              TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### enumConstantFieldInternal

          protected final void enumConstantFieldInternal(AST mods,
                                                         AST tp,
                                                         AST t,
                                                         Token first)
                                                  throws RecognitionException,
                                                         TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### compoundStatement

          public final void compoundStatement()
                                       throws RecognitionException,
                                              TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### parameterDeclarationList

          public final void parameterDeclarationList()
                                              throws RecognitionException,
                                                     TokenStreamException

      A list of zero or more formal parameters. If a parameter is variable length (e.g. String... myArg) it should be to the right of any other parameters of the same kind. General form: (req, ..., opt, ..., [rest], key, ..., [restKeys], [block] This must be sorted out after parsing, since the various declaration forms are impossible to tell apart without backtracking.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### throwsClause

          public final void throwsClause()
                                  throws RecognitionException,
                                         TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### constructorDefinition

          public final void constructorDefinition(AST mods)
                                           throws RecognitionException,
                                                  TokenStreamException

      I've split out constructors separately; we could maybe integrate back into variableDefinitions later on if we maybe simplified 'def' to be a type declaration?
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### multipleAssignmentDeclarationStart

          public final void multipleAssignmentDeclarationStart()
                                                        throws RecognitionException,
                                                               TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### multipleAssignmentDeclaration

          public final void multipleAssignmentDeclaration()
                                                   throws RecognitionException,
                                                          TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### constructorBody

          public final void constructorBody()
                                     throws RecognitionException,
                                            TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### explicitConstructorInvocation

          public final void explicitConstructorInvocation()
                                                   throws RecognitionException,
                                                          TokenStreamException

      Catch obvious constructor calls, but not the expr.super(...) calls
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### listOfVariables

          public final void listOfVariables(AST mods,
                                            AST t,
                                            Token first)
                                     throws RecognitionException,
                                            TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### variableDeclarator

          public final void variableDeclarator(AST mods,
                                               AST t,
                                               Token first)
                                        throws RecognitionException,
                                               TokenStreamException

      Declaration of a variable. This can be a class/instance variable, or a local variable in a method It can also include possible initialization.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### typeNamePairs

          public final void typeNamePairs(AST mods,
                                          Token first)
                                   throws RecognitionException,
                                          TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### assignmentExpression

          public final void assignmentExpression(int lc_stmt)
                                          throws RecognitionException,
                                                 TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### nlsWarn

          public final void nlsWarn()
                             throws RecognitionException,
                                    TokenStreamException

      Zero or more insignificant newlines, all gobbled up and thrown away, but a warning message is left for the user, if there was a newline.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### openBlock

          public final void openBlock()
                               throws RecognitionException,
                                      TokenStreamException

      An open block is not allowed to have closure arguments.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### variableName

          public final void variableName()
                                  throws RecognitionException,
                                         TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### expressionStatementNoCheck

          public final void expressionStatementNoCheck()
                                                throws RecognitionException,
                                                       TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### parameterDeclaration

          public final void parameterDeclaration()
                                          throws RecognitionException,
                                                 TokenStreamException

      A formal parameter for a method or closure.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### parameterModifiersOpt

          public final void parameterModifiersOpt()
                                           throws RecognitionException,
                                                  TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### multicatch_types

          public final void multicatch_types()
                                      throws RecognitionException,
                                             TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### multicatch

          public final void multicatch()
                                throws RecognitionException,
                                       TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### closableBlockParamsOpt

          public final void closableBlockParamsOpt(boolean addImplicit)
                                            throws RecognitionException,
                                                   TokenStreamException

      Closure parameters are exactly like method parameters, except that they are not enclosed in parentheses, but rather are prepended to the front of a block, just after the brace. They are separated from the closure body by a CLOSABLE_BLOCK_OP token '->'.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### implicitParameters

          public final void implicitParameters()
                                        throws RecognitionException,
                                               TokenStreamException

      A block known to be a closure, but which omits its arguments, is given this placeholder. A subsequent pass is responsible for deciding if there is an implicit 'it' parameter, or if the parameter list should be empty.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### closableBlockParamsStart

          public final void closableBlockParamsStart()
                                              throws RecognitionException,
                                                     TokenStreamException

      Lookahead to check whether a block begins with explicit closure arguments.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### closableBlockParam

          public final void closableBlockParam()
                                        throws RecognitionException,
                                               TokenStreamException

      Simple names, as in {x|...}, are completely equivalent to {(def x)|...}. Build the right AST.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### closableBlock

          public final void closableBlock()
                                   throws RecognitionException,
                                          TokenStreamException

      A block which is known to be a closure, even if it has no apparent arguments. A block inside an expression or after a method call is always assumed to be a closure. Only labeled, unparameterized blocks which occur directly as substatements are kept open.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### openOrClosableBlock

          public final void openOrClosableBlock()
                                         throws RecognitionException,
                                                TokenStreamException

      A sub-block of a block can be either open or closable. It is closable if and only if there are explicit closure arguments. Compare this to a block which is appended to a method call, which is given closure arguments, even if they are not explicit in the code.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### statementLabelPrefix

          public final void statementLabelPrefix()
                                          throws RecognitionException,
                                                 TokenStreamException

      A labeled statement, consisting of a vanilla identifier followed by a colon.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### expressionStatement

          public final void expressionStatement(int prevToken)
                                         throws RecognitionException,
                                                TokenStreamException

      An expression statement can be any general expression.

      An expression statement can also be a command, which is a simple method call in which the outermost parentheses are omitted.

      Certain "suspicious" looking forms are flagged for the user to disambiguate.

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### assignmentLessExpression

          public final void assignmentLessExpression()
                                              throws RecognitionException,
                                                     TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### compatibleBodyStatement

          public final void compatibleBodyStatement()
                                             throws RecognitionException,
                                                    TokenStreamException

      In Java, "if", "while", and "for" statements can take random, non-braced statements as their bodies. Support this practice, even though it isn't very Groovy.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### forStatement

          public final void forStatement()
                                  throws RecognitionException,
                                         TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### strictContextExpression

          public final boolean strictContextExpression(boolean allowDeclaration)
                                                throws RecognitionException,
                                                       TokenStreamException

      Things that can show up as expressions, but only in strict contexts like inside parentheses, argument lists, and list constructors.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### casesGroup

          public final void casesGroup()
                                throws RecognitionException,
                                       TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### tryBlock

          public final void tryBlock()
                              throws RecognitionException,
                                     TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### branchStatement

          public final void branchStatement()
                                     throws RecognitionException,
                                            TokenStreamException

      In Groovy, return, break, continue, throw, and assert can be used in a parenthesized expression context. Example: println (x || (return)); println assert x, "won't print a false value!" If an optional expression is missing, its value is void (this coerces to null when a value is required).
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### closureList

          public final void closureList()
                                 throws RecognitionException,
                                        TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### forInClause

          public final void forInClause()
                                 throws RecognitionException,
                                        TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### shiftExpression

          public final void shiftExpression(int lc_stmt)
                                     throws RecognitionException,
                                            TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### expression

          public final void expression(int lc_stmt)
                                throws RecognitionException,
                                       TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### suspiciousExpressionStatementStart

          public final void suspiciousExpressionStatementStart()
                                                        throws RecognitionException,
                                                               TokenStreamException

      Lookahead for suspicious statement warnings and errors.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### checkSuspiciousExpressionStatement

          public final void checkSuspiciousExpressionStatement(int prevToken)
                                                        throws RecognitionException,
                                                               TokenStreamException

      If two statements are separated by newline (not SEMI), the second had better not look like the latter half of an expression. If it does, issue a warning.

      Also, if the expression starts with a closure, it needs to have an explicit parameter list, in order to avoid the appearance of a compound statement. This is a hard error.

      These rules are different from Java's "dumb expression" restriction. Unlike Java, Groovy blocks can end with arbitrary (even dumb) expressions, as a consequence of optional 'return' and 'continue' tokens.

      To make the programmer's intention clear, a leading closure must have an explicit parameter list, and must not follow a previous statement separated only by newlines.

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### commandArgumentsGreedy

          public final void commandArgumentsGreedy(AST head)
                                            throws RecognitionException,
                                                   TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### aCase

          public final void aCase()
                           throws RecognitionException,
                                  TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### caseSList

          public final void caseSList()
                               throws RecognitionException,
                                      TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### forInit

          public final void forInit()
                             throws RecognitionException,
                                    TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### controlExpressionList

          public final void controlExpressionList()
                                           throws RecognitionException,
                                                  TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### forCond

          public final void forCond()
                             throws RecognitionException,
                                    TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### forIter

          public final void forIter()
                             throws RecognitionException,
                                    TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### handler

          public final void handler()
                             throws RecognitionException,
                                    TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### finallyClause

          public final void finallyClause()
                                   throws RecognitionException,
                                          TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### commandArguments

          public final void commandArguments(AST head)
                                      throws RecognitionException,
                                             TokenStreamException

      A member name (x.y) or element name (x[y]) can serve as a command name, which may be followed by a list of arguments. Unlike parenthesized arguments, these must be plain expressions, without labels or spread operators.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### commandArgument

          public final void commandArgument()
                                     throws RecognitionException,
                                            TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### primaryExpression

          public final void primaryExpression()
                                       throws RecognitionException,
                                              TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### pathElementStart

          public final void pathElementStart()
                                      throws RecognitionException,
                                             TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### pathChain

          public final void pathChain(int lc_stmt,
                                      AST prefix)
                               throws RecognitionException,
                                      TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### argumentLabel

          public final void argumentLabel()
                                   throws RecognitionException,
                                          TokenStreamException

      A label for an argument is of the form a:b, 'a':b, "a":b, (a):b, etc.. The labels in (a:b), ('a':b), and ("a":b) are in all ways equivalent, except that the quotes allow more spellings. Equivalent dynamically computed labels are (('a'):b) and ("${'a'}":b) but not ((a):b) or "$a":b, since the latter cases evaluate (a) as a normal identifier. Bottom line: If you want a truly variable label, use parens and say ((a):b).
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### multipleAssignment

          public final void multipleAssignment(int lc_stmt)
                                        throws RecognitionException,
                                               TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### pathElement

          public final void pathElement(AST prefix)
                                 throws RecognitionException,
                                        TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### appendedBlock

          public final void appendedBlock(AST callee)
                                   throws RecognitionException,
                                          TokenStreamException

      An appended block follows any expression. If the expression is not a method call, it is given an empty argument list.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### pathExpression

          public final void pathExpression(int lc_stmt)
                                    throws RecognitionException,
                                           TokenStreamException

      A "path expression" is a name or other primary, possibly qualified by various forms of dot, and/or followed by various kinds of brackets. It can be used for value or assigned to, or else further qualified, indexed, or called. It is called a "path" because it looks like a linear path through a data structure. Examples: x.y, x?.y, x*.y, x.@y; x[], x[y], x[y,z]; x(), x(y), x(y,z); x{s}; a.b[n].c(x).d{s} (Compare to a C lvalue, or LeftHandSide in the JLS section 15.26.) General expressions are built up from path expressions, using operators like '+' and '='.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### namePart

          public final void namePart()
                              throws RecognitionException,
                                     TokenStreamException

      This is the grammar for what can follow a dot: x.a, x.@a, x.&a, x.'a', etc. Note: `typeArguments` is handled by the caller of `namePart`.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### methodCallArgs

          public final void methodCallArgs(AST callee)
                                    throws RecognitionException,
                                           TokenStreamException

      An expression may be followed by one or both of (...) and {...}. Note: If either is (...) or {...} present, it is a method call. The {...} is appended to the argument list, and matches a formal of type Closure. If there is no method member, a property (or field) is used instead, and must itself be callable.

      If the methodCallArgs are absent, it is a property reference. If there is no property, it is treated as a field reference, but never a method reference.

      Arguments in the (...) can be labeled, and the appended block can be labeled also. If there is a mix of unlabeled and labeled arguments, all the labeled arguments must follow the unlabeled arguments, except that the closure (labeled or not) is always a separate final argument. Labeled arguments are collected up and passed as a single argument to a formal of type Map.

      Therefore, f(x,y, a:p, b:q) {s} is equivalent in all ways to f(x,y, [a:p,b:q], {s}). Spread arguments of sequence type count as unlabeled arguments, while spread arguments of map type count as labeled arguments. (This distinction must sometimes be checked dynamically.) A plain unlabeled argument is allowed to match a trailing Map or Closure argument: f(x, a:p) {s} === f(*[ x, [a:p], {s} ])

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### indexPropertyArgs

          public final void indexPropertyArgs(AST indexee)
                                       throws RecognitionException,
                                              TokenStreamException

      An expression may be followed by [...]. Unlike Java, these brackets may contain a general argument list, which is passed to the array element operator, which can make of it what it wants. The brackets may also be empty, as in T[]. This is how Groovy names array types.

      Returned AST is [INDEX_OP, indexee, ELIST].

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### dynamicMemberName

          public final void dynamicMemberName()
                                       throws RecognitionException,
                                              TokenStreamException

      If a dot is followed by a parenthesized or quoted expression, the member is computed dynamically, and the member selection is done only at runtime. This forces a statically unchecked member access.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### parenthesizedExpression

          public final void parenthesizedExpression()
                                             throws RecognitionException,
                                                    TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### stringConstructorExpression

          public final void stringConstructorExpression()
                                                 throws RecognitionException,
                                                        TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### logicalOrExpression

          public final void logicalOrExpression(int lc_stmt)
                                         throws RecognitionException,
                                                TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### logicalAndExpression

          public final void logicalAndExpression(int lc_stmt)
                                          throws RecognitionException,
                                                 TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### inclusiveOrExpression

          public final void inclusiveOrExpression(int lc_stmt)
                                           throws RecognitionException,
                                                  TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### exclusiveOrExpression

          public final void exclusiveOrExpression(int lc_stmt)
                                           throws RecognitionException,
                                                  TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### andExpression

          public final void andExpression(int lc_stmt)
                                   throws RecognitionException,
                                          TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### regexExpression

          public final void regexExpression(int lc_stmt)
                                     throws RecognitionException,
                                            TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### equalityExpression

          public final void equalityExpression(int lc_stmt)
                                        throws RecognitionException,
                                               TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### relationalExpression

          public final void relationalExpression(int lc_stmt)
                                          throws RecognitionException,
                                                 TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### additiveExpression

          public final void additiveExpression(int lc_stmt)
                                        throws RecognitionException,
                                               TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### multiplicativeExpression

          public final void multiplicativeExpression(int lc_stmt)
                                              throws RecognitionException,
                                                     TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### powerExpressionNotPlusMinus

          public final void powerExpressionNotPlusMinus(int lc_stmt)
                                                 throws RecognitionException,
                                                        TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### powerExpression

          public final void powerExpression(int lc_stmt)
                                     throws RecognitionException,
                                            TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### unaryExpression

          public final void unaryExpression(int lc_stmt)
                                     throws RecognitionException,
                                            TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### unaryExpressionNotPlusMinus

          public final void unaryExpressionNotPlusMinus(int lc_stmt)
                                                 throws RecognitionException,
                                                        TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### postfixExpression

          public final void postfixExpression(int lc_stmt)
                                       throws RecognitionException,
                                              TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### constant

          public final void constant()
                              throws RecognitionException,
                                     TokenStreamException

      Numeric, string, regexp, boolean, or null constant.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### newExpression

          public final void newExpression()
                                   throws RecognitionException,
                                          TokenStreamException

      object instantiation. Trees are built as illustrated by the following input/tree pairs: new T() new | T -- ELIST | arg1 -- arg2 -- .. -- argn new int[] new | int -- ARRAY_DECLARATOR new int[] {1,2} new | int -- ARRAY_DECLARATOR -- ARRAY_INIT | EXPR -- EXPR | | 1 2 new int[3] new | int -- ARRAY_DECLARATOR | EXPR | 3 new int[1][2] new | int -- ARRAY_DECLARATOR | ARRAY_DECLARATOR -- EXPR | | EXPR 1 | 2
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### closableBlockConstructorExpression

          public final void closableBlockConstructorExpression()
                                                        throws RecognitionException,
                                                               TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### listOrMapConstructorExpression

          public final void listOrMapConstructorExpression()
                                                    throws RecognitionException,
                                                           TokenStreamException

      A list constructor is a argument list enclosed in square brackets, without labels. Any argument can be decorated with a spread operator (*x), but not a label (a:x). Examples: [], [1], [1,2], [1,*l1,2], [*l1,*l2]. (The l1, l2 must be a sequence or null.)

      A map constructor is an argument list enclosed in square brackets, with labels everywhere, except on spread arguments, which stand for whole maps spliced in. A colon alone between the brackets also forces the expression to be an empty map constructor. Examples: [:], [a:1], [a:1,b:2], [a:1,*:m1,b:2], [*:m1,*:m2] (The m1, m2 must be a map or null.) Values associated with identical keys overwrite from left to right: [a:1,a:2] === [a:2]

      Some malformed constructor expressions are not detected in the parser, but in a post-pass. Bad examples: [1,b:2], [a:1,2], [:1]. (Note that method call arguments, by contrast, can be a mix of keyworded and non-keyworded arguments.)

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### stringConstructorValuePart

          public final void stringConstructorValuePart()
                                                throws RecognitionException,
                                                       TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### newArrayDeclarator

          public final void newArrayDeclarator()
                                        throws RecognitionException,
                                               TokenStreamException

      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### argument

          public final byte argument()
                              throws RecognitionException,
                                     TokenStreamException

      A single argument in (...) or [...]. Corresponds to to a method or closure parameter. May be labeled. May be modified by the spread operator '*' ('*:' for keywords).
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### argumentLabelStart

          public final void argumentLabelStart()
                                        throws RecognitionException,
                                               TokenStreamException

      For lookahead only. Fast approximate parse of an argumentLabel followed by a colon.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### constantNumber

          public final void constantNumber()
                                    throws RecognitionException,
                                           TokenStreamException

      Numeric constant.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### balancedBrackets

          public final void balancedBrackets()
                                      throws RecognitionException,
                                             TokenStreamException

      Fast lookahead across balanced brackets of all sorts.
      Throws:
        `RecognitionException`
        `TokenStreamException`

    - #### buildTokenTypeASTClassMap

          protected void buildTokenTypeASTClassMap()